.milestones-steps {
  --step-icon-size: 4rem;
  --step-icon-border-width: 4px;
  --color--line: var(--wp--preset--color--grey-300);
  display: flex;
  flex-direction: column;
}

.milestone-step {
  position: relative;
  display: flex;
  flex: 1;
  gap: 16px;
}

.milestone-step:not(:last-of-type) {
  padding-bottom: 48px;
}

@media (min-width: 768px) {
  .milestones-steps[data-align="horizontal"] {
    flex-direction: row;
  }

  .milestones-steps[data-align="horizontal"] .milestone-step {
    flex-direction: column;
    padding-bottom: 0;
  }
}

.milestone-step::before,
.milestone-step::after {
  content: "";
  position: absolute;
  display: block;
}

.milestone-step:not(:last-of-type)::before,
.milestone-step:not(:last-of-type)::after {
  left: calc(var(--step-icon-size) / 2);
  transform: translateX(-50%);
  width: var(--step-icon-border-width);
  height: 100%;
}

.milestone-step:not(:last-of-type)::before {
  background-color: var(--color--line);
}

.milestone-step:not(:last-of-type)::after {
  background: var(--wp--preset--color--primary);
  transform: translateX(-50%) scaleY(0);
  transform-origin: top;
  transition: transform 0.5s ease;
}

.milestone-step.milestone-step--complete::after {
  transform: translateX(-50%) scaleY(1);
}

@media (min-width: 768px) {
  .milestones-steps[data-align="horizontal"] .milestone-step:not(:last-of-type)::before,
  .milestones-steps[data-align="horizontal"] .milestone-step:not(:last-of-type)::after {
    top: calc(var(--step-icon-size) / 2);
    left: 50%;
    width: 100%;
    height: var(--step-icon-border-width);
    transform: translateY(-50%);
    transform-origin: left;
  }

  .milestones-steps[data-align="horizontal"] .milestone-step:not(:last-of-type)::after {
    transform: translateY(-50%) scaleX(0);
    transition: transform 0.5s ease;
  }

  .milestones-steps[data-align="horizontal"] .milestone-step--complete:not(:last-of-type)::after {
    transform: translateY(-50%) scaleX(1);
  }
}

.step__icon {
  position: relative;
  z-index: 1;
  display: flex;
  align-items: center;
  justify-content: center;
  flex-shrink: 0;
  width: var(--step-icon-size);
  height: var(--step-icon-size);
  border-radius: 50%;
  font-size: 1rem;
  background: var(--wp--preset--color--grey-500);
  border: var(--step-icon-border-width) solid var(--color--line);
  transition:
    background-color 0.25s ease,
    border-color 0.25s ease;
}

@media (min-width: 768px) {
  .milestones-steps[data-align="horizontal"] .step__icon {
    margin-inline: auto;
  }
}

.milestone-step--complete .step__icon {
  background: var(--wp--preset--color--primary);
  border-color: var(--wp--preset--color--primary);
}

.milestone-step--complete .step__icon::before {
  content: "✓";
  color: var(--wp--preset--color--white);
}

.milestone-step--active:not(.milestone-step--complete) .step__icon {
  background: var(--color-body);
}

.milestone-step--active.milestone-step--incomplete .step__icon {
  border-color: var(--wp--preset--color--primary);
}

.milestone-step--incomplete:not(.milestone-step--active) .step__icon::before,
.milestone-step--incomplete:not(.milestone-step--active) .step__icon::after {
  content: "";
  position: absolute;
  background: var(--color--line);
}

.milestones-steps[data-align="vertical"] .milestone-step--incomplete:not(:first-of-type):not(.milestone-step--active) .step__icon::before {
  top: -12px;
  width: var(--step-icon-border-width);
  height: 12px;
}

.milestones-steps[data-align="vertical"] .milestone-step--incomplete:not(:last-of-type):not(.milestone-step--active) .step__icon::after {
  bottom: -12px;
  width: var(--step-icon-border-width);
  height: 12px;
}

@media (min-width: 768px) {
  .milestones-steps[data-align="horizontal"] .milestone-step--incomplete:not(:first-of-type):not(.milestone-step--active) .step__icon::before {
    left: -12px;
    width: 12px;
    height: var(--step-icon-border-width);
  }

  .milestones-steps[data-align="horizontal"] .milestone-step--incomplete:not(:last-of-type):not(.milestone-step--active) .step__icon::after {
    right: -12px;
    width: 12px;
    height: var(--step-icon-border-width);
  }
}

.step__content {
  margin-top: var(--wp--custom--space-xxs);
  transition: color 0.3s ease;
}

.milestone-step--incomplete .step__content {
  color: var(--wp--preset--color--grey-600);
}

@media (min-width: 768px) {
  .milestones-steps[data-align="horizontal"] .step__content {
    margin-top: 1.5rem;
    text-align: center;
  }
}

.step__title {
  margin: 0;
}

.editor-styles-wrapper .wp-block-custom-milestones > ul.milestones-steps > .block-editor-inner-blocks > .block-editor-block-list__layout {
  display: flex;
  flex-direction: row;
}

.editor-styles-wrapper
  .wp-block-custom-milestones.block-milestones--vertical
  > ul.milestones-steps
  > .block-editor-inner-blocks
  > .block-editor-block-list__layout {
  display: flex;
  flex-direction: column;
}

.editor-styles-wrapper .wp-block-custom-milestones .milestone-step {
  list-style: none;
}

.editor-styles-wrapper .wp-block-custom-milestones > ul.milestones-steps > .block-editor-inner-blocks,
.editor-styles-wrapper .wp-block-custom-milestones > ul.milestones-steps > .block-editor-inner-blocks > .block-editor-block-list__layout {
  width: 100%;
}
